// Picture.cpp: implementation of the CPicture class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Picture.h"

#include "activeimage.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPicture::CPicture()
{
	m_pPicture	= NULL;
}

CPicture::~CPicture()
{
	UnLoad();
}




void CPicture::UnLoad()
{
	if (m_pPicture != NULL)
	{
		m_pPicture->Release();
		m_pPicture = NULL;
	}
}

bool CPicture::Draw(CDC* pDC)
{
	if (m_pPicture != NULL)
	{
		long hmWidth;
		long hmHeight;
		m_pPicture->get_Width(&hmWidth);
		m_pPicture->get_Height(&hmHeight);

		int nWidth	= MulDiv(hmWidth,	pDC->GetDeviceCaps(LOGPIXELSX), HIMETRIC_INCH);
		int nHeight	= MulDiv(hmHeight,	pDC->GetDeviceCaps(LOGPIXELSY), HIMETRIC_INCH);
		
		return Draw(pDC, 0, 0, nWidth, nHeight);
	}
	return false;
}


bool CPicture::Draw(CDC* pDC, int x, int y, int cx, int cy)
{
	long hmWidth;
	long hmHeight;
	m_pPicture->get_Width(&hmWidth);
	m_pPicture->get_Height(&hmHeight);

	if (m_pPicture->Render(pDC->m_hDC, x, y, cx, cy, 0, hmHeight, hmWidth, -hmHeight, NULL) == S_OK)
		return true;

	return false;
}

bool CPicture::LoadFromBuffer(BYTE* pBuff, int nSize)
{
	bool bResult = false;

	HGLOBAL hGlobal = GlobalAlloc(GMEM_MOVEABLE, nSize);
	void* pData = GlobalLock(hGlobal);
	memcpy(pData, pBuff, nSize);
	GlobalUnlock(hGlobal);

	IStream* pStream = NULL;

	if (CreateStreamOnHGlobal(hGlobal, TRUE, &pStream) == S_OK)
	{
		HRESULT hr;
		if ((hr = OleLoadPicture(pStream, nSize, FALSE, IID_IPicture, (LPVOID *)&m_pPicture)) == S_OK)
			bResult = true;
	
		pStream->Release();
	}

	return bResult;
}





bool CPicture::ActiveImageTest()
{
	VARIANT w;

	BYTE* pBuff;
	long lBound;
	long uBound;

	IImages im1;
	im1.CreateDispatch("activeimage.Images");

	//im1.CreateImage(10,10);
	//im1.SetImageType(1);
	im1.ReadFromFile("C:/diagram.png");
	im1.SetImageType(3);
	im1.ConvertToPalette();
	im1.WriteToFile("C:/test.gif");

	VariantInit(&w);
	w = im1.WriteToVariableVariant();

	if ((w.vt & VT_ARRAY))
	{
		
		SAFEARRAY* pSA;
		pSA= w.parray;


		SafeArrayGetUBound(pSA,1,&uBound);
		SafeArrayGetLBound(pSA,1,&lBound);

		pBuff = new BYTE[uBound+1];

		for(long j=lBound; j <=uBound;j++)
		{			
			VARIANT v;
			VariantInit(&v);
			
			SafeArrayGetElement(pSA,&j,&v);
			
			if (v.bVal!=NULL) 
			{			
				pBuff[j] = v.bVal;			
			}
			else
			{
				pBuff[j] = 0;
			}
		}
	
	if (m_pPicture != NULL)
		UnLoad();	
	LoadFromBuffer(pBuff, uBound+1);

	delete [] pBuff;

	}

	return S_OK;
}
